
;//*==========================================================================;
;//*
;//*  Copyright (C) Microsoft Corporation.  All Rights Reserved.
;//*
;//*  File:   d3d9.h
;//*  Content:    Direct3D include file
;//*
;//****************************************************************************/

DIRECT3D_VERSION    =  0x0900
D3D_SDK_VERSION     =  32
D3D9b_SDK_VERSION   =  31

;//
;// Interface IID's
;//

IID_IDirect3D9               dd  0x81BDCBCA, 0x426D64D4, 0x01AD8DAE, 0x5C27F447
IID_HelperName               dd  0xE4A36723, 0x4B22FDFE, 0x043C46B1, 0xC84C7FC0

IDirect3DBaseTexture9        dd  0x580CA87E, 0x4D541D3C, 0xD3B71D99, 0xCE98C2E3
IDirect3DCubeTexture9        dd  0xFFF32F81, 0x473AD953, 0xD6932392, 0x3FA9AB52
IDirect3DDevice9             dd  0xD0223B96, 0x43FDBF7A, 0x3BA4BD92, 0xEBB9820D
IDirect3DIndexBuffer9        dd  0x7C9DD65E, 0x4529D3F7, 0x5878EEAC, 0x35DEAC30
IDirect3DPixelShader9        dd  0x6D3BDBDC, 0x44155B02, 0x5ECE52B8, 0x89B2CC8B
IDirect3DQuery9              dd  0xD9771460, 0x4F26A695, 0xB827D3BB, 0xCC41B540
IDirect3DResource9           dd  0x05EEC05D, 0x43628F7D, 0xBAD199B9, 0x04C757F3
IDirect3DStateBlock9         dd  0xB07C4FE5, 0x4BA8310D, 0x0F4F3CA2, 0x8B216F20
IDirect3DSurface9            dd  0x0CFBAF3A, 0x429A9FF6, 0x79A2B399, 0x9BB8F86A
IDirect3DSwapChain9          dd  0x794950F2, 0x458AADFC, 0xA1105E90, 0x3B500B0B
IDirect3DTexture9            dd  0x85C31227, 0x4F003DE5, 0x1AF13A9B, 0xB5188CC3
IDirect3DVertexBuffer9       dd  0xB64BB1B5, 0x4DF6FD70, 0xD01991BF, 0xE35524A1
IDirect3DVertexDeclaration9  dd  0xDD13C59C, 0x409836FA, 0xEDC7FBA8, 0x4685DC39
IDirect3DVertexShader9       dd  0xEFC5557E, 0x46136265, 0x8543948A, 0x36EB8978
IDirect3DVolume9             dd  0x24F416E6, 0x4AA71F67, 0x3FD38EB8, 0xA128316F
IDirect3DVolumeTexture9      dd  0x2518526C, 0x4111E789, 0xEF47B9A7, 0xE6138D32

;// D3D9Ex only ------//

IDirect3D9Ex                    dd  0x02177241, 0x400C69FC, 0xA493F18F, 0x1D86F64D
IDirect3D9ExOverlayExtension    dd  0x187AEB13, 0x4C59AAF5, 0x59E06D87, 0xF80D8C08
IDirect3DAuthenticatedChannel9  dd  0xFF24BEEE, 0x4BEBDA21, 0xF8D2B598, 0xF98AF999
IDirect3DCryptoSession9         dd  0xFA0AB799, 0x48CA7A9C, 0x7E235B8C, 0x3444A571  
IDirect3DDevice9Ex              dd  0xB18B10CE, 0x405A2649, 0xF7950F87, 0x3A31D477
IDirect3DDevice9Video           dd  0x26DC4561, 0x4AE7A1EE, 0x8A11DA96, 0x95ECC036
IDirect3DSwapChain9Ex           dd  0x91886CAF, 0x4D2E1C3D, 0x4C3EABA0, 0x03338D7D

if 0
-----------------------------------------------------------------
    Direct3D9. 
        Direct3DDevice9. 
   D3D_SDK_VERSION   ,     , 
       : 
IDirect3D9 * WINAPI Direct3DCreate9 (UINT SDKVersion);
*
* Stubs for graphics profiling.
*
int   WINAPI D3DPERF_BeginEvent( D3DCOLOR col, LPCWSTR wszName );
int   WINAPI D3DPERF_EndEvent  ( void );
void  WINAPI D3DPERF_SetMarker ( D3DCOLOR col, LPCWSTR wszName );
void  WINAPI D3DPERF_SetRegion ( D3DCOLOR col, LPCWSTR wszName );
BOOL  WINAPI D3DPERF_QueryRepeatFrame( void );
void  WINAPI D3DPERF_SetOptions( DWORD dwOptions );
DWORD WINAPI D3DPERF_GetStatus( void );
-----------------------------------------------------------------
end if

;//
;// Direct3D interfaces
;//

interface  IDirect3D9,\
    QueryInterface,\
    AddRef,\
    Release,\
    RegisterSoftwareDevice,\    
    GetAdapterCount,\    
    GetAdapterIdentifier,\    
    GetAdapterModeCount,\    
    EnumAdapterModes,\    
    GetAdapterDisplayMode,\    
    CheckDeviceType,\    
    CheckDeviceFormat,\    
    CheckDeviceMultiSampleType,\    
    CheckDepthStencilMatch,\    
    CheckDeviceFormatConversion,\    
    GetDeviceCaps,\    
    GetAdapterMonitor,\    
    CreateDevice
        
interface  IDirect3DDevice9,\
    QueryInterface,\
    AddRef,\
    Release,\
    TestCooperativeLevel,\
    GetAvailableTextureMem,\
    EvictManagedResources,\
    GetDirect3D,\
    GetDeviceCaps,\
    GetDisplayMode,\
    GetCreationParameters,\
    SetCursorProperties,\
    SetCursorPosition,\
    ShowCursor,\
    CreateAdditionalSwapChain,\
    GetSwapChain,\
    GetNumberOfSwapChains,\
    Reset,\
    Present,\
    GetBackBuffer,\
    GetRasterStatus,\
    SetDialogBoxMode,\
    SetGammaRamp,\
    GetGammaRamp,\
    CreateTexture,\
    CreateVolumeTexture,\
    CreateCubeTexture,\
    CreateVertexBuffer,\
    CreateIndexBuffer,\
    CreateRenderTarget,\
    CreateDepthStencilSurface,\
    UpdateSurface,\
    UpdateTexture,\
    GetRenderTargetData,\
    GetFrontBufferData,\
    StretchRect,\
    ColorFill,\
    CreateOffscreenPlainSurface,\
    SetRenderTarget,\
    GetRenderTarget,\
    SetDepthStencilSurface,\
    GetDepthStencilSurface,\
    BeginScene,\
    EndScene,\
    Clear,\
    SetTransform,\
    GetTransform,\
    MultiplyTransform,\
    SetViewport,\
    GetViewport,\
    SetMaterial,\
    GetMaterial,\
    SetLight,\
    GetLight,\
    LightEnable,\
    GetLightEnable,\
    SetClipPlane,\
    GetClipPlane,\
    SetRenderState,\
    GetRenderState,\
    CreateStateBlock,\
    BeginStateBlock,\
    EndStateBlock,\
    SetClipStatus,\
    GetClipStatus,\
    GetTexture,\
    SetTexture,\
    GetTextureStageState,\
    SetTextureStageState,\
    GetSamplerState,\
    SetSamplerState,\
    ValidateDevice,\
    SetPaletteEntries,\
    GetPaletteEntries,\
    SetCurrentTexturePalette,\
    GetCurrentTexturePalette,\
    SetScissorRect,\
    GetScissorRect,\
    SetSoftwareVertexProcessing,\
    GetSoftwareVertexProcessing,\
    SetNPatchMode,\
    GetNPatchMode,\
    DrawPrimitive,\
    DrawIndexedPrimitive,\
    DrawPrimitiveUP,\
    DrawIndexedPrimitiveUP,\
    ProcessVertices,\
    CreateVertexDeclaration,\
    SetVertexDeclaration,\
    GetVertexDeclaration,\
    SetFVF,\
    GetFVF,\
    CreateVertexShader,\
    SetVertexShader,\
    GetVertexShader,\
    SetVertexShaderConstantF,\
    GetVertexShaderConstantF,\
    SetVertexShaderConstantI,\
    GetVertexShaderConstantI,\
    SetVertexShaderConstantB,\
    GetVertexShaderConstantB,\
    SetStreamSource,\
    GetStreamSource,\
    SetStreamSourceFreq,\
    GetStreamSourceFreq,\
    SetIndices,\
    GetIndices,\
    CreatePixelShader,\
    SetPixelShader,\
    GetPixelShader,\
    SetPixelShaderConstantF,\
    GetPixelShaderConstantF,\
    SetPixelShaderConstantI,\
    GetPixelShaderConstantI,\
    SetPixelShaderConstantB,\
    GetPixelShaderConstantB,\
    DrawRectPatch,\
    DrawTriPatch,\
    DeletePatch,\
    CreateQuery

interface  IDirect3DStateBlock9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    Capture,\
    Apply

interface  IDirect3DSwapChain9,\
    QueryInterface,\
    AddRef,\
    Release,\
    Present,\
    GetFrontBufferData,\
    GetBackBuffer,\
    GetRasterStatus,\
    GetDisplayMode,\
    GetDevice,\
    GetPresentParameters

interface  IDirect3DResource9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType
    
interface  IDirect3DVertexDeclaration9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    GetDeclaration
    
interface  IDirect3DVertexShader9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    GetFunction

interface  IDirect3DPixelShader9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    GetFunction
    
interface  IDirect3DBaseTexture9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    SetLOD,\
    GetLOD,\
    GetLevelCount,\
    SetAutoGenFilterType,\
    GetAutoGenFilterType,\
    GenerateMipSubLevels
    
interface  IDirect3DTexture9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    SetLOD,\
    GetLOD,\
    GetLevelCount,\
    SetAutoGenFilterType,\
    GetAutoGenFilterType,\
    GenerateMipSubLevels,\
    GetLevelDesc,\
    GetSurfaceLevel,\
    LockRect,\
    UnlockRect,\
    AddDirtyRect

interface  IDirect3DVolumeTexture9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    SetLOD,\
    GetLOD,\
    GetLevelCount,\
    SetAutoGenFilterType,\
    GetAutoGenFilterType,\
    GenerateMipSubLevels,\
    GetLevelDesc,\
    GetVolumeLevel,\
    LockBox,\
    UnlockBox,\
    AddDirtyBox
  
interface  IDirect3DCubeTexture9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    SetLOD,\
    GetLOD,\
    GetLevelCount,\
    SetAutoGenFilterType,\
    GetAutoGenFilterType,\
    GenerateMipSubLevels,\
    GetLevelDesc,\
    GetCubeMapSurface,\
    LockRect,\
    UnlockRect,\
    AddDirtyRect

interface  IDirect3DVertexBuffer9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    Lock,\
    Unlock,\
    GetDesc

interface  IDirect3DIndexBuffer9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    Lock,\
    Unlock,\
    GetDesc
  
interface  IDirect3DSurface9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    SetPriority,\
    GetPriority,\
    PreLoad,\
    GetType,\
    GetContainer,\
    GetDesc,\
    LockRect,\
    UnlockRect,\
    GetDC,\
    ReleaseDC

interface  IDirect3DVolume9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    SetPrivateData,\
    GetPrivateData,\
    FreePrivateData,\
    GetContainer,\
    GetDesc,\
    LockBox,\
    UnlockBox

interface  IDirect3DQuery9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetDevice,\
    GetType,\
    GetDataSize,\
    Issue,\
    GetData

;/***********************************
;/*   D3D9Ex interfaces
;/*   HRESULT WINAPI Direct3DCreate9Ex(UINT SDKVersion, IDirect3D9Ex**);
;/***********************************

interface  IDirect3D9Ex,\
    QueryInterface,\
    AddRef,\
    Release,\
    RegisterSoftwareDevice,\    
    GetAdapterCount,\    
    GetAdapterIdentifier,\    
    GetAdapterModeCount,\    
    EnumAdapterModes,\    
    GetAdapterDisplayMode,\    
    CheckDeviceType,\    
    CheckDeviceFormat,\    
    CheckDeviceMultiSampleType,\    
    CheckDepthStencilMatch,\    
    CheckDeviceFormatConversion,\    
    GetDeviceCaps,\    
    GetAdapterMonitor,\    
    CreateDevice,\
    GetAdapterModeCountEx,\
    EnumAdapterModesEx,\
    GetAdapterDisplayModeEx,\
    CreateDeviceEx,\
    GetAdapterLUID

interface  IDirect3DDevice9Ex,\
    QueryInterface,\
    AddRef,\
    Release,\
    TestCooperativeLevel,\
    GetAvailableTextureMem,\
    EvictManagedResources,\
    GetDirect3D,\
    GetDeviceCaps,\
    GetDisplayMode,\
    GetCreationParameters,\
    SetCursorProperties,\
    SetCursorPosition,\
    ShowCursor,\
    CreateAdditionalSwapChain,\
    GetSwapChain,\
    GetNumberOfSwapChains,\
    Reset,\
    Present,\
    GetBackBuffer,\
    GetRasterStatus,\
    SetDialogBoxMode,\
    SetGammaRamp,\
    GetGammaRamp,\
    CreateTexture,\
    CreateVolumeTexture,\
    CreateCubeTexture,\
    CreateVertexBuffer,\
    CreateIndexBuffer,\
    CreateRenderTarget,\
    CreateDepthStencilSurface,\
    UpdateSurface,\
    UpdateTexture,\
    GetRenderTargetData,\
    GetFrontBufferData,\
    StretchRect,\
    ColorFill,\
    CreateOffscreenPlainSurface,\
    SetRenderTarget,\
    GetRenderTarget,\
    SetDepthStencilSurface,\
    GetDepthStencilSurface,\
    BeginScene,\
    EndScene,\
    Clear,\
    SetTransform,\
    GetTransform,\
    MultiplyTransform,\
    SetViewport,\
    GetViewport,\
    SetMaterial,\
    GetMaterial,\
    SetLight,\
    GetLight,\
    LightEnable,\
    GetLightEnable,\
    SetClipPlane,\
    GetClipPlane,\
    SetRenderState,\
    GetRenderState,\
    CreateStateBlock,\
    BeginStateBlock,\
    EndStateBlock,\
    SetClipStatus,\
    GetClipStatus,\
    GetTexture,\
    SetTexture,\
    GetTextureStageState,\
    SetTextureStageState,\
    GetSamplerState,\
    SetSamplerState,\
    ValidateDevice,\
    SetPaletteEntries,\
    GetPaletteEntries,\
    SetCurrentTexturePalette,\
    GetCurrentTexturePalette,\
    SetScissorRect,\
    GetScissorRect,\
    SetSoftwareVertexProcessing,\
    GetSoftwareVertexProcessing,\
    SetNPatchMode,\
    GetNPatchMode,\
    DrawPrimitive,\
    DrawIndexedPrimitive,\
    DrawPrimitiveUP,\
    DrawIndexedPrimitiveUP,\
    ProcessVertices,\
    CreateVertexDeclaration,\
    SetVertexDeclaration,\
    GetVertexDeclaration,\
    SetFVF,\
    GetFVF,\
    CreateVertexShader,\
    SetVertexShader,\
    GetVertexShader,\
    SetVertexShaderConstantF,\
    GetVertexShaderConstantF,\
    SetVertexShaderConstantI,\
    GetVertexShaderConstantI,\
    SetVertexShaderConstantB,\
    GetVertexShaderConstantB,\
    SetStreamSource,\
    GetStreamSource,\
    SetStreamSourceFreq,\
    GetStreamSourceFreq,\
    SetIndices,\
    GetIndices,\
    CreatePixelShader,\
    SetPixelShader,\
    GetPixelShader,\
    SetPixelShaderConstantF,\
    GetPixelShaderConstantF,\
    SetPixelShaderConstantI,\
    GetPixelShaderConstantI,\
    SetPixelShaderConstantB,\
    GetPixelShaderConstantB,\
    DrawRectPatch,\
    DrawTriPatch,\
    DeletePatch,\
    CreateQuery,\
    CreateRenderTargetEx,\
    CreateOffscreenPlainSurfaceEx,\
    CreateDepthStencilSurfaceEx,\
    ResetEx,\
    GetDisplayModeEx

interface  IDirect3DDevice9Video,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetContentProtectionCaps,\
    CreateAuthenticatedChannel,\
    CreateCryptoSession
    
interface  IDirect3DAuthenticatedChannel9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetCertificateSize,\
    GetCertificate,\
    NegotiateKeyExchange,\
    Query,\
    Configure

interface  IDirect3DCryptoSession9,\
    QueryInterface,\
    AddRef,\
    Release,\
    GetCertificateSize,\
    GetCertificate,\
    NegotiateKeyExchange,\
    EncryptionBlt,\
    DecryptionBlt,\
    GetSurfacePitch,\
    StartSessionKeyRefresh,\
    FinishSessionKeyRefresh,\
    GetEncryptionBltKey

if 0
/****************************************************************************
  SetPrivateData    D3D9.

    IUnknown ptr. 
 SizeOfData  SetPrivateData    sizeof(IUnknown*). 
Direct3D  AddRef     Release,     . 
  ,     SetPrivateData    GUID, 
  FreePrivateData    D3D9 . 
/****************************************************************************
end if
 
D3DSPD_IUNKNOWN    =  1

if 0
/****************************************************************************
 * Flags for IDirect3D9::CreateDevice's BehaviorFlags
 ****************************************************************************/
end if

D3DCREATE_ADAPTERGROUP_DEVICE           =  0x00000200
D3DCREATE_DISABLE_DRIVER_MANAGEMENT     =  0x00000100
D3DCREATE_DISABLE_DRIVER_MANAGEMENT_EX  =  0x00000400
D3DCREATE_FPU_PRESERVE                  =  0x00000002
D3DCREATE_HARDWARE_VERTEXPROCESSING     =  0x00000040
D3DCREATE_MIXED_VERTEXPROCESSING        =  0x00000080
D3DCREATE_MULTITHREADED                 =  0x00000004
D3DCREATE_PUREDEVICE                    =  0x00000010
D3DCREATE_SOFTWARE_VERTEXPROCESSING     =  0x00000020

if 0
     D3D -    .
   -      (alt-tab  ..)   ,
   (    ..)   .
end if

D3DCREATE_DISABLE_PRINTSCREEN     =  0x00008000
D3DCREATE_DISABLE_PSGP_THREADING  =  0x00002000
D3DCREATE_ENABLE_PRESENTSTATS     =  0x00004000
D3DCREATE_NOWINDOWCHANGES         =  0x00000800
D3DCREATE_SCREENSAVER             =  0x10000000

;/****************************************************************************
; * Parameter for IDirect3D9::CreateDevice's Adapter argument
;/****************************************************************************

D3DADAPTER_DEFAULT   =  0

;/****************************************************************************
; * Flags for IDirect3D9::EnumAdapters
;/****************************************************************************/
if 0
 D3DENUM_WHQL_LEVEL   9Ex   , 
        DX9    . 
. DirectX SDK       .
end if

D3DCURSOR_IMMEDIATE_UPDATE             =  0x00000001
D3DENUM_NO_DRIVERVERSION               =  0x00000004
D3DENUM_WHQL_LEVEL                     =  0x00000002
D3DPRESENT_BACK_BUFFERS_MAX            =  0x00000003
D3DPRESENT_BACK_BUFFERS_MAX_EX         =  0x00000030
D3DPRESENT_DONOTFLIP                   =  0x00000004
D3DPRESENT_DONOTWAIT                   =  0x00000001
D3DPRESENT_FLIPRESTART                 =  0x00000008
D3DPRESENT_FORCEIMMEDIATE              =  0x00000100
D3DPRESENT_HIDEOVERLAY                 =  0x00000040
D3DPRESENT_LINEAR_CONTENT              =  0x00000002
D3DPRESENT_UPDATECOLORKEY              =  0x00000080
D3DPRESENT_UPDATEOVERLAYONLY           =  0x00000020
D3DPRESENT_VIDEO_RESTRICT_TO_MONITOR   =  0x00000010
D3DSGR_CALIBRATE                       =  0x00000001
D3DSGR_NO_CALIBRATION                  =  0x00000000

if 0
--------------------------------------
;//
;// Direct3D Errors
;//

_FACD3D  =  0x876
D3D_OK   =  0      ; S_OK

D3DERR_CONFLICTINGRENDERSTATE           MAKE_D3DHRESULT(2081)
D3DERR_CONFLICTINGTEXTUREFILTER         MAKE_D3DHRESULT(2078)
D3DERR_CONFLICTINGTEXTUREPALETTE        MAKE_D3DHRESULT(2086)
D3DERR_DRIVERINTERNALERROR              MAKE_D3DHRESULT(2087)
D3DERR_TOOMANYOPERATIONS                MAKE_D3DHRESULT(2077)
D3DERR_UNSUPPORTEDALPHAARG              MAKE_D3DHRESULT(2076)
D3DERR_UNSUPPORTEDALPHAOPERATION        MAKE_D3DHRESULT(2075)
D3DERR_UNSUPPORTEDCOLORARG              MAKE_D3DHRESULT(2074)
D3DERR_UNSUPPORTEDCOLOROPERATION        MAKE_D3DHRESULT(2073)
D3DERR_UNSUPPORTEDFACTORVALUE           MAKE_D3DHRESULT(2079)
D3DERR_UNSUPPORTEDTEXTUREFILTER         MAKE_D3DHRESULT(2082)
D3DERR_WRONGTEXTUREFORMAT               MAKE_D3DHRESULT(2072)

D3DERR_DEVICELOST                       MAKE_D3DHRESULT(2152)
D3DERR_DEVICENOTRESET                   MAKE_D3DHRESULT(2153)
D3DERR_DRIVERINVALIDCALL                MAKE_D3DHRESULT(2157)
D3DERR_INVALIDCALL                      MAKE_D3DHRESULT(2156)
D3DERR_INVALIDDEVICE                    MAKE_D3DHRESULT(2155)
D3DERR_MOREDATA                         MAKE_D3DHRESULT(2151)
D3DERR_NOTAVAILABLE                     MAKE_D3DHRESULT(2154)
D3DERR_NOTFOUND                         MAKE_D3DHRESULT(2150)
D3DERR_OUTOFVIDEOMEMORY                 MAKE_D3DHRESULT(380)
D3DERR_WASSTILLDRAWING                  MAKE_D3DHRESULT(540)
D3DOK_NOAUTOGEN                         MAKE_D3DSTATUS(2159)

/* D3D9Ex only -- */
#if !defined(D3D_DISABLE_9EX)

D3DERR_CANNOTPROTECTCONTENT             MAKE_D3DHRESULT(2173)
D3DERR_DEVICEHUNG                       MAKE_D3DHRESULT(2164)
D3DERR_DEVICEREMOVED                    MAKE_D3DHRESULT(2160)
D3DERR_PRESENT_STATISTICS_DISJOINT      MAKE_D3DHRESULT(2180)
D3DERR_UNSUPPORTEDCRYPTO                MAKE_D3DHRESULT(2174)
D3DERR_UNSUPPORTEDOVERLAY               MAKE_D3DHRESULT(2171)
D3DERR_UNSUPPORTEDOVERLAYFORMAT         MAKE_D3DHRESULT(2172)
S_NOT_RESIDENT                          MAKE_D3DSTATUS(2165)
S_PRESENT_MODE_CHANGED                  MAKE_D3DSTATUS(2167)
S_PRESENT_OCCLUDED                      MAKE_D3DSTATUS(2168)
S_RESIDENT_IN_SHARED_MEMORY             MAKE_D3DSTATUS(2166)
--------------------------------------
end if

struct  D3DDISPLAYMODE
   Width        dd  0
   Height       dd  0
   RefreshRate  dd  0
   Format       dd  0
ends

struct  D3DGAMMARAMP
   red          rw  256
   green        rw  256
   blue         rw  256
ends

MAX_DEVICE_IDENTIFIER_STRING=512

struct  D3DADAPTER_IDENTIFIER
  Driver          rb  MAX_DEVICE_IDENTIFIER_STRING
  Description     rb  MAX_DEVICE_IDENTIFIER_STRING
  DeviceName      rb  32
  DriverVerMajor  dd  0
  DriverVerMinor  dd  0
  VendorId        dd  0
  DeviceId        dd  0
  SubSysId        dd  0
  Revision        dd  0
  DeviceGuid      rb  16
  WHQLLevel       dd  0
ends















